/*
 * mailto:rk@tbkoenig.de
 *
 * Klar, schlechter Stil. Dafr aber mit viel Liebe
 * programmiert. ;-)
 *
 */

#if defined(__BORLANDC__) || (_MSC_VER >= 1200)
  #pragma hdrstop
#endif

#include <windows.h>
#include <tchar.h>
#include <conwnd.h>  // conwnd.h mu sich im Include-Verzeichnis befinden!

#define SHADOW_ATTR    BUILD_TEXTATTR(BLACK, BLACK)
#define SHADOW_CHAR    TEXT(' ')
#define WINDOW_CHAR    TEXT(' ')

typedef struct tagCONWNDINFO
{
    UINT   uX;
    UINT   uY;
    UINT   uWidth;
    UINT   uHeight;
    INT    nShadow;
    INT    nBorder;
    DWORD* pdwAttributes;
    TCHAR* pcChars;
    struct tagCONWNDINFO* pNext;
} CONWNDINFO, *PCONWNDINFO, *LPCONWNDINFO;

typedef struct tagCONWNDBORDERINFO
{
    TCHAR  cTopLeft;
    TCHAR  cTop;
    TCHAR  cTopRight;
    TCHAR  cLeft;
    TCHAR  cRight;
    TCHAR  cBottomLeft;
    TCHAR  cBottom;
    TCHAR  cBottomRight;
} CONWNDBORDERINFO, *PCONWNDBORDERINFO, *LPCONWNDBORDERINFO;

static const CONWNDBORDERINFO g_Border[] =
{
  {  TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT('')  },   //Single
  {  TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT('')  },   //Double
  {  TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT('')  },   //Mixed12
  {  TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT(''), TEXT('')  },   //Mixed21
  {  TEXT('*'), TEXT('*'), TEXT('*'), TEXT('*'), TEXT('*'), TEXT('*'), TEXT('*'), TEXT('*')  }    //Stars
};

static PCONWNDINFO g_pWndInfo = NULL;

BOOL TBK_CONWNDAPI MakeWindow(UINT uX, UINT uY, UINT uWidth, UINT uHeight, WORD wAttribute, INT nBorder, INT nShadow)
{
  PCONWNDINFO pInfo;
  HANDLE      hOutput, hHeap;
  DWORD       dwError, dwDummy;
  COORD       coord;
  UINT        x, y, width, height;

    uX--;
    uY--;

    if(INVALID_HANDLE_VALUE == (hOutput = GetStdHandle(STD_OUTPUT_HANDLE)))
        return(FALSE);
    if(NULL == (hHeap = GetProcessHeap()))
        return(FALSE);

    switch(nShadow)
    {
        case CONWND_SHADOW_LEFT:
             x      = uX - 2;
             y      = uY;
             width  = uWidth + 2;
             height = uHeight + 1;
             break;
        case CONWND_SHADOW_RIGHT:
             x      = uX;
             y      = uY;
             width  = uWidth + 2;
             height = uHeight + 1;
             break;
        default:
             x       = uX;
             y       = uY;
             width   = uWidth;
             height  = uHeight;
             break;
    }

    dwError = ERROR_OUTOFMEMORY;

    if(NULL != (pInfo = (PCONWNDINFO)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, sizeof(*pInfo))))
        if(NULL != (pInfo->pdwAttributes = (PDWORD)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, (width * height) * sizeof(*pInfo->pdwAttributes))))
            if(NULL != (pInfo->pcChars = (TCHAR*)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, (width * height) * sizeof(*pInfo->pcChars))))
                dwError = ERROR_SUCCESS;

    if(ERROR_SUCCESS != dwError)
    {
        if(pInfo)
        {
            if(pInfo->pdwAttributes)
                HeapFree(hHeap, 0, (PVOID)pInfo->pdwAttributes);
            if(pInfo->pcChars)
                HeapFree(hHeap, 0, (PVOID)pInfo->pcChars);

            HeapFree(hHeap, 0, (PVOID)pInfo);
        }
        SetLastError(dwError);
        return(FALSE);
    }

    pInfo->uX      = uX;
    pInfo->uY      = uY;
    pInfo->uWidth  = uWidth;
    pInfo->uHeight = uHeight;
    pInfo->nShadow = nShadow;
    pInfo->nBorder = nBorder;
    pInfo->pNext   = g_pWndInfo;
    g_pWndInfo     = pInfo;

    for(uY = 0, coord.X = (SHORT)x, coord.Y = (SHORT)y; uY < height; uY++, coord.Y++)
    {
        ReadConsoleOutputAttribute(hOutput, (USHORT*)&pInfo->pdwAttributes[uY * width], width, coord, &dwDummy);
        ReadConsoleOutputCharacter(hOutput, &pInfo->pcChars[uY * width], width, coord, &dwDummy);
    }

    for(uY = 0, coord.X = (SHORT)pInfo->uX, coord.Y = (SHORT)y; uY < uHeight; uY++, coord.Y++)
    {
        FillConsoleOutputAttribute(hOutput, wAttribute, pInfo->uWidth, coord, &dwDummy);
        FillConsoleOutputCharacter(hOutput, WINDOW_CHAR, pInfo->uWidth, coord, &dwDummy);
    }

    switch(nShadow)
    {
        case CONWND_SHADOW_LEFT:
             coord.X = (SHORT)(pInfo->uX - 2);
             coord.Y = (SHORT)(y + uHeight);
             FillConsoleOutputAttribute(hOutput, SHADOW_ATTR, uWidth, coord, &dwDummy);
             FillConsoleOutputCharacter(hOutput, SHADOW_CHAR, uWidth, coord, &dwDummy);

             for(--coord.Y; coord.Y > (SHORT)pInfo->uY; coord.Y--)
             {
                 FillConsoleOutputAttribute(hOutput, SHADOW_ATTR, 2, coord, &dwDummy);
                 FillConsoleOutputCharacter(hOutput, SHADOW_CHAR, 2, coord, &dwDummy);
             }
             break;
        case CONWND_SHADOW_RIGHT:
             coord.X = (SHORT)(x + 1);
             coord.Y = (SHORT)(y + uHeight);
             FillConsoleOutputAttribute(hOutput, SHADOW_ATTR, uWidth, coord, &dwDummy);
             FillConsoleOutputCharacter(hOutput, SHADOW_CHAR, uWidth, coord, &dwDummy);

             for(coord.X = (SHORT)(coord.X + pInfo->uWidth - 1); coord.Y > (SHORT)pInfo->uY; coord.Y--)
             {
                 FillConsoleOutputAttribute(hOutput, SHADOW_ATTR, 2, coord, &dwDummy);
                 FillConsoleOutputCharacter(hOutput, SHADOW_CHAR, 2, coord, &dwDummy);
             }
             break;
        default:
             break;
    }

    if((nBorder < (sizeof(g_Border) / sizeof(g_Border[0]))) && (pInfo->uWidth >= 3))
    {
        coord.X = (SHORT)(pInfo->uX);
        coord.Y = (SHORT)(pInfo->uY);
        FillConsoleOutputCharacter(hOutput, g_Border[nBorder].cTopLeft, 1, coord, &dwDummy);

        coord.X++;
        FillConsoleOutputCharacter(hOutput, g_Border[nBorder].cTop, pInfo->uWidth - 2, coord, &dwDummy);

        coord.X = (SHORT)(pInfo->uX + pInfo->uWidth - 1);
        FillConsoleOutputCharacter(hOutput, g_Border[nBorder].cTopRight, 1, coord, &dwDummy);

        for(++coord.Y, uY = pInfo->uHeight - 2; uY; uY--, coord.Y++)
            FillConsoleOutputCharacter(hOutput, g_Border[nBorder].cRight, 1, coord, &dwDummy);

        FillConsoleOutputCharacter(hOutput, g_Border[nBorder].cBottomRight, 1, coord, &dwDummy);

        coord.X = (SHORT)(pInfo->uX + 1);
        FillConsoleOutputCharacter(hOutput, g_Border[nBorder].cBottom, pInfo->uWidth - 2, coord, &dwDummy);

        coord.X--;
        FillConsoleOutputCharacter(hOutput, g_Border[nBorder].cBottomLeft, 1, coord, &dwDummy);

        for(--coord.Y; coord.Y > (SHORT)pInfo->uY; coord.Y--)
            FillConsoleOutputCharacter(hOutput, g_Border[nBorder].cLeft, 1, coord, &dwDummy);
    }
  return(TRUE);
}

BOOL TBK_CONWNDAPI RemoveWindow(VOID)
{
  PCONWNDINFO pInfo;
  HANDLE      hOutput, hHeap;
  COORD       coord;
  DWORD       dwDummy;
  UINT        width, y2, uIndex;

    if(!g_pWndInfo)
    {
        // There is no window to remove
        SetLastError(ERROR_SUCCESS);
        return(FALSE);
    }

    hHeap      = GetProcessHeap();
    pInfo      = g_pWndInfo;
    g_pWndInfo = pInfo->pNext;

    switch(pInfo->nShadow)
    {
        case CONWND_SHADOW_LEFT:
             coord.X = (SHORT)(pInfo->uX - 2);
             coord.Y = (SHORT)(pInfo->uY);
             width   = pInfo->uWidth + 2;
             y2      = pInfo->uHeight + coord.Y + 1;
             break;
        case CONWND_SHADOW_RIGHT:
             coord.X = (SHORT)(pInfo->uX);
             coord.Y = (SHORT)(pInfo->uY);
             width   = pInfo->uWidth + 2;
             y2      = pInfo->uHeight + coord.Y + 1;
             break;
        default:
             coord.X = (SHORT)(pInfo->uX);
             coord.Y = (SHORT)(pInfo->uY);
             width   = pInfo->uWidth;
             y2      = pInfo->uHeight + coord.Y;
             break;
    }

    if(INVALID_HANDLE_VALUE != (hOutput = GetStdHandle(STD_OUTPUT_HANDLE)))
    {
        for(uIndex = 0; (SHORT)y2 > coord.Y; coord.Y++, uIndex++)
        {
            WriteConsoleOutputAttribute(hOutput, (USHORT*)&pInfo->pdwAttributes[uIndex * width], width, coord, &dwDummy);
            WriteConsoleOutputCharacter(hOutput, &pInfo->pcChars[uIndex * width], width, coord, &dwDummy);
        }
    }

    HeapFree(hHeap, 0, (PVOID)pInfo->pdwAttributes);
    HeapFree(hHeap, 0, (PVOID)pInfo->pcChars);
    HeapFree(hHeap, 0, (PVOID)pInfo);

  return(TRUE);
}

BOOL TBK_CONWNDAPI PrintWindow(UINT uX, UINT uY, LPCTSTR lpstrText)
{
  HANDLE hOutput;
  DWORD  dwLen;
  COORD  coord;

    if(!lpstrText)
    {
        SetLastError(ERROR_INVALID_PARAMETER);
        return(FALSE);
    }

    if(!g_pWndInfo)
    {
        SetLastError((DWORD)E_FAIL);
        return(FALSE);
    }

    if(INVALID_HANDLE_VALUE == (hOutput = GetStdHandle(STD_OUTPUT_HANDLE)))
        return(FALSE);

    coord.X = (USHORT)(g_pWndInfo->uX + uX - 1);
    coord.Y = (USHORT)(g_pWndInfo->uY + uY - 1);

    if(0 != (dwLen = _tcslen(lpstrText)))
        WriteConsoleOutputCharacter(hOutput, lpstrText, dwLen, coord, &dwLen);

  return(TRUE);
}

BOOL TBK_CONWNDAPI PrintCWindow(UINT uY, LPCTSTR lpstrText)
{
  HANDLE hOutput;
  DWORD  dwLen;
  COORD  coord;

    if(!lpstrText)
    {
        SetLastError(ERROR_INVALID_PARAMETER);
        return(FALSE);
    }

    if(!g_pWndInfo)
    {
        SetLastError((DWORD)E_FAIL);
        return(FALSE);
    }

    if(INVALID_HANDLE_VALUE == (hOutput = GetStdHandle(STD_OUTPUT_HANDLE)))
        return(FALSE);

    if(0 != (dwLen = _tcslen(lpstrText)))
    {
        coord.X = (USHORT)(((g_pWndInfo->uWidth - dwLen) / 2) + g_pWndInfo->uX);
        coord.Y = (USHORT)(g_pWndInfo->uY + uY - 1);
        WriteConsoleOutputCharacter(hOutput, lpstrText, dwLen, coord, &dwLen);
    }

  return(TRUE);
}

BOOL TBK_CONWNDAPI TitleWindow(INT nType, LPCTSTR lpstrTitle)
{
  DWORD dwLen;

    if(!lpstrTitle)
    {
        SetLastError(ERROR_INVALID_PARAMETER);
        return(FALSE);
    }

    if(!g_pWndInfo)
    {
        SetLastError((DWORD)E_FAIL);
        return(FALSE);
    }

    switch(nType)
    {
        case CONWND_TITLE_TOPLEFT:
             return(PrintWindow(2, 1, lpstrTitle));
        case CONWND_TITLE_TOPCENTER:
             return(PrintCWindow(1, lpstrTitle));
        case CONWND_TITLE_TOPRIGHT:
             if(0 != (dwLen = _tcslen(lpstrTitle)))
                 return(PrintWindow(g_pWndInfo->uWidth - dwLen, 1, lpstrTitle));
             return(TRUE);
        case CONWND_TITLE_BOTTOMLEFT:
             return(PrintWindow(2, g_pWndInfo->uHeight, lpstrTitle));
        case CONWND_TITLE_BOTTOMCENTER:
             return(PrintCWindow(g_pWndInfo->uHeight, lpstrTitle));
        case CONWND_TITLE_BOTTOMRIGHT:
             if(0 != (dwLen = _tcslen(lpstrTitle)))
                 return(PrintWindow(g_pWndInfo->uWidth - dwLen, g_pWndInfo->uHeight, lpstrTitle));
             break;
        default:
             SetLastError(ERROR_INVALID_PARAMETER);
             break;
    }

  return(FALSE);
}

BOOL TBK_CONWNDAPI ClearWindow(VOID)
{
  HANDLE hOutput;
  COORD  coord;
  DWORD  dwDummy;
  UINT   width, height;

    if(!g_pWndInfo)
    {
        //There is no Window to clear
        SetLastError(ERROR_SUCCESS);
        return(FALSE);
    }

    if(INVALID_HANDLE_VALUE == (hOutput = GetStdHandle(STD_OUTPUT_HANDLE)))
        return(FALSE);

    if((g_pWndInfo->nBorder < (sizeof(g_Border) / sizeof(g_Border[0]))) && (g_pWndInfo->uWidth >= 3))
    {
        coord.X = (USHORT)(g_pWndInfo->uX + 1);
        coord.Y = (USHORT)(g_pWndInfo->uY + g_pWndInfo->uHeight - 2);
        width   = g_pWndInfo->uWidth - 2;
        height  = g_pWndInfo->uHeight - 2;
    }
    else
    {
        coord.X = (USHORT)(g_pWndInfo->uX);
        coord.Y = (USHORT)(g_pWndInfo->uY + g_pWndInfo->uHeight - 1);
        width   = g_pWndInfo->uWidth;
        height  = g_pWndInfo->uHeight;
    }

    while(height)
    {
        FillConsoleOutputCharacter(hOutput, WINDOW_CHAR, width, coord, &dwDummy);
        coord.Y--;
        height--;
    }
  return(TRUE);
}
