#ifndef   CONWND_H
  #define CONWND_H

    #if (!defined(_WIN32)) || (defined(_MSC_VER) && !defined(_CONSOLE))
      #error Only Win32-Console-Targets supported
    #endif

    #define TBK_CONWNDAPI             __stdcall

    // valid values for the nBorder parameter in MakeWindow calls
    #define CONWND_BORDER_SINGLE      0x00000000
    #define CONWND_BORDER_DOUBLE      0x00000001
    #define CONWND_BORDER_MIXED12     0x00000002
    #define CONWND_BORDER_MIXED21     0x00000003
    #define CONWND_BORDER_STARS       0x00000004
    #define CONWND_BORDER_NONE        0x7FFFFFFF

    // valid values for the nShadow parameter in MakeWindow calls
    #define CONWND_NO_SHADOW          0x00000000
    #define CONWND_SHADOW_LEFT        0x00000001
    #define CONWND_SHADOW_RIGHT       0x00000002

    // valid values for the nType parameter in TitleWindow calls
    #define CONWND_TITLE_TOPLEFT      0x00000001
    #define CONWND_TITLE_TOPCENTER    0x00000002
    #define CONWND_TITLE_TOPRIGHT     0x00000003
    #define CONWND_TITLE_BOTTOMLEFT   0x00000004
    #define CONWND_TITLE_BOTTOMCENTER 0x00000005
    #define CONWND_TITLE_BOTTOMRIGHT  0x00000006

    #ifndef __COLORS
      #define __COLORS

        enum COLORS
        {
            BLACK,          /* dark colors */
            BLUE,
            GREEN,
            CYAN,
            RED,
            MAGENTA,
            BROWN,
            LIGHTGRAY,
            DARKGRAY,       /* light colors */
            LIGHTBLUE,
            LIGHTGREEN,
            LIGHTCYAN,
            LIGHTRED,
            LIGHTMAGENTA,
            YELLOW,
            WHITE
        };
    #endif

    #ifndef BUILD_TEXTATTR
      #define BUILD_TEXTATTR(f, b)    (int)((((b) & 15) << 4) | ((f) & 15))
    #endif

    #ifdef __cplusplus
      extern "C" {
    #endif

    //creates and displays a new window
    BOOL TBK_CONWNDAPI MakeWindow(UINT uX, UINT uY, UINT uWidth, UINT uHeight, WORD wAttribute, INT nBorder, INT nShadow);

    //removes the last created window
    BOOL TBK_CONWNDAPI RemoveWindow(VOID);

    //prints text into the last created window
    BOOL TBK_CONWNDAPI PrintWindow(UINT uX, UINT uY, LPCTSTR lpstrText);

    //prints horizontal centered text into the last created window
    BOOL TBK_CONWNDAPI PrintCWindow(UINT uY, LPCTSTR lpstrText);

    //titles the last created window
    BOOL TBK_CONWNDAPI TitleWindow(INT nType, LPCTSTR lpstrTitle);

    //clears the last created window
    BOOL TBK_CONWNDAPI ClearWindow(VOID);

    #ifdef __cplusplus
      }
    #endif

#endif
