/*
 * Dieses Testprogramm bentigt zur korrekten Funktion
 * das Modul conioex. Ihr knnt Euch das auch im CPP-Archiv
 * ziehen. Es reicht nicht, einfach den Header zu includieren.
 * Es mssen noch die beiden Dateien conioex.c und conwnd.c
 * dem Project hinzugefgt werden.
 *
 * Wichtig: Die Header-Files mssen gefunden werden. In diesem
 * Beispiel gehe ich davon aus, da sie sich in einem der eingestellen
 * Include-Verzeichnisse befinden.
 *
 * Alle Fenster, die mit MakeWindow erzeugt wurden, sollten mit
 * RemoveWindow gelscht werden (wenn sie nicht mehr gebraucht
 * werden). Dies stellt sicher, da von MakeWindow angeforderte
 * Speicher wieder freigegeben wird.
 *
 * mailto:rk@tbkoenig.de
 *
 */

#include <windows.h>
#include <tchar.h>
#include <conio.h>
#include <conioex.h> // conioex.h mu sich im Include-Verzeichnis befinden!
#include <conwnd.h>  // conwnd.h mu sich im Include-Verzeichnis befinden!

int _tmain(void)
{
    // Funktionen aus conioex
    _setcursortype(_NOCURSOR);
    textbackground(BLUE);
    clrscr();
    
    // Fenster 1 erzeugen, betiteln, zentrierten Text in Zeile 5 ausgeben
    MakeWindow( 5, 5, 40, 10, BUILD_TEXTATTR(BLACK, CYAN), CONWND_BORDER_SINGLE, CONWND_SHADOW_RIGHT);
    TitleWindow(CONWND_TITLE_TOPCENTER, TEXT("Fenster-Titel"));
    PrintCWindow(5, TEXT("Fensterschatten Rechts"));
    Sleep(2500);
    
    // Fenster 2 erzeugen, zentrierten Text in Zeile 5 ausgeben
    MakeWindow( 8,  8, 40, 10, BUILD_TEXTATTR(LIGHTGRAY, RED), CONWND_BORDER_SINGLE, CONWND_SHADOW_LEFT);
    PrintCWindow(5, TEXT("Fensterschatten Links"));
    Sleep(2500);

    // Fenster 3 erzeugen, zentrierten Text in Zeile 5 ausgeben
    // Text in Zeile 6/Spalte 5 ausgeben
    MakeWindow(11, 11, 40, 10, BUILD_TEXTATTR(WHITE, GREEN), CONWND_BORDER_SINGLE, CONWND_NO_SHADOW);
    PrintCWindow(5, TEXT("Kein Fensterschatten"));
    PrintWindow(2, 6, TEXT("Gleich wird der Fensterinhalt gelscht"));
    Sleep(5000);

    // Inhalt von Fenster 3 lschen
    ClearWindow();
    Sleep(2500);
    
    // Entfernt Fenster 3
    RemoveWindow();
    Sleep(2500);
    
    // Entfernt Fenster 2
    RemoveWindow();
    Sleep(2500);
    
    // Entfernt Fenster 1
    RemoveWindow();
    
    _getch();

    // Funktionen aus conioex
    textbackground(BLACK);
    clrscr();
    _setcursortype(_NORMALCURSOR);
  
  return(0);
}
